Allow mailsplit (and hence git-am) to handle mails with CRLF line-endings
[git/dscho.git] / git-am.sh
blob985226bfecb8a208fda1f57cec80870c79e289dc
1 #!/bin/sh
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [<mbox>|<Maildir>...]
9 git am [options] (--resolved | --skip | --abort)
11 i,interactive run interactively
12 b,binary* (historical option -- no-op)
13 3,3way allow fall back on 3way merging if needed
14 q,quiet be quiet
15 s,signoff add a Signed-off-by line to the commit message
16 u,utf8 recode into utf8 (default)
17 k,keep pass -k flag to git-mailinfo
18 whitespace= pass it through git-apply
19 directory= pass it through git-apply
20 C= pass it through git-apply
21 p= pass it through git-apply
22 patch-format= format the patch(es) are in
23 reject pass it through git-apply
24 resolvemsg= override error message when patch failure occurs
25 r,resolved to be used after a patch failure
26 skip skip the current patch
27 abort restore the original branch and abort the patching operation.
28 committer-date-is-author-date lie about committer date
29 ignore-date use current timestamp for author date
30 rebasing* (internal use for git-rebase)"
32 . git-sh-setup
33 prefix=$(git rev-parse --show-prefix)
34 set_reflog_action am
35 require_work_tree
36 cd_to_toplevel
38 git var GIT_COMMITTER_IDENT >/dev/null ||
39 die "You need to set your committer info first"
41 if git rev-parse --verify -q HEAD >/dev/null
42 then
43 HAS_HEAD=yes
44 else
45 HAS_HEAD=
48 sq () {
49 git rev-parse --sq-quote "$@"
52 stop_here () {
53 echo "$1" >"$dotest/next"
54 exit 1
57 stop_here_user_resolve () {
58 if [ -n "$resolvemsg" ]; then
59 printf '%s\n' "$resolvemsg"
60 stop_here $1
62 cmdline="git am"
63 if test '' != "$interactive"
64 then
65 cmdline="$cmdline -i"
67 if test '' != "$threeway"
68 then
69 cmdline="$cmdline -3"
71 echo "When you have resolved this problem run \"$cmdline --resolved\"."
72 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
73 echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
75 stop_here $1
78 go_next () {
79 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
80 "$dotest/patch" "$dotest/info"
81 echo "$next" >"$dotest/next"
82 this=$next
85 cannot_fallback () {
86 echo "$1"
87 echo "Cannot fall back to three-way merge."
88 exit 1
91 fall_back_3way () {
92 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
94 rm -fr "$dotest"/patch-merge-*
95 mkdir "$dotest/patch-merge-tmp-dir"
97 # First see if the patch records the index info that we can use.
98 git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
99 "$dotest/patch" &&
100 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
101 git write-tree >"$dotest/patch-merge-base+" ||
102 cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
104 say Using index info to reconstruct a base tree...
105 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
106 git apply --cached <"$dotest/patch"
107 then
108 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
109 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
110 else
111 cannot_fallback "Did you hand edit your patch?
112 It does not apply to blobs recorded in its index."
115 test -f "$dotest/patch-merge-index" &&
116 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
117 orig_tree=$(cat "$dotest/patch-merge-base") &&
118 rm -fr "$dotest"/patch-merge-* || exit 1
120 say Falling back to patching base and 3-way merge...
122 # This is not so wrong. Depending on which base we picked,
123 # orig_tree may be wildly different from ours, but his_tree
124 # has the same set of wildly different changes in parts the
125 # patch did not touch, so recursive ends up canceling them,
126 # saying that we reverted all those changes.
128 eval GITHEAD_$his_tree='"$FIRSTLINE"'
129 export GITHEAD_$his_tree
130 if test -n "$GIT_QUIET"
131 then
132 export GIT_MERGE_VERBOSITY=0
134 git-merge-recursive $orig_tree -- HEAD $his_tree || {
135 git rerere
136 echo Failed to merge in the changes.
137 exit 1
139 unset GITHEAD_$his_tree
142 clean_abort () {
143 test $# = 0 || echo >&2 "$@"
144 rm -fr "$dotest"
145 exit 1
148 patch_format=
150 check_patch_format () {
151 # early return if patch_format was set from the command line
152 if test -n "$patch_format"
153 then
154 return 0
157 # we default to mbox format if input is from stdin and for
158 # directories
159 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
160 then
161 patch_format=mbox
162 return 0
165 # otherwise, check the first few lines of the first patch to try
166 # to detect its format
168 read l1
169 read l2
170 read l3
171 case "$l1" in
172 "From "* | "From: "*)
173 patch_format=mbox
175 '# This series applies on GIT commit'*)
176 patch_format=stgit-series
178 "# HG changeset patch")
179 patch_format=hg
182 # if the second line is empty and the third is
183 # a From, Author or Date entry, this is very
184 # likely an StGIT patch
185 case "$l2,$l3" in
186 ,"From: "* | ,"Author: "* | ,"Date: "*)
187 patch_format=stgit
191 esac
193 esac
194 } < "$1" || clean_abort
197 split_patches () {
198 case "$patch_format" in
199 mbox)
200 case "$rebasing" in
202 keep_cr= ;;
204 keep_cr=--keep-cr ;;
205 esac
206 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
207 clean_abort
209 stgit-series)
210 if test $# -ne 1
211 then
212 clean_abort "Only one StGIT patch series can be applied at once"
214 series_dir=`dirname "$1"`
215 series_file="$1"
216 shift
218 set x
219 while read filename
221 set "$@" "$series_dir/$filename"
222 done
223 # remove the safety x
224 shift
225 # remove the arg coming from the first-line comment
226 shift
227 } < "$series_file" || clean_abort
228 # set the patch format appropriately
229 patch_format=stgit
230 # now handle the actual StGIT patches
231 split_patches "$@"
233 stgit)
234 this=0
235 for stgit in "$@"
237 this=`expr "$this" + 1`
238 msgnum=`printf "%0${prec}d" $this`
239 # Perl version of StGIT parse_patch. The first nonemptyline
240 # not starting with Author, From or Date is the
241 # subject, and the body starts with the next nonempty
242 # line not starting with Author, From or Date
243 perl -ne 'BEGIN { $subject = 0 }
244 if ($subject > 1) { print ; }
245 elsif (/^\s+$/) { next ; }
246 elsif (/^Author:/) { print s/Author/From/ ; }
247 elsif (/^(From|Date)/) { print ; }
248 elsif ($subject) {
249 $subject = 2 ;
250 print "\n" ;
251 print ;
252 } else {
253 print "Subject: ", $_ ;
254 $subject = 1;
256 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
257 done
258 echo "$this" > "$dotest/last"
259 this=
260 msgnum=
263 clean_abort "Patch format $patch_format is not supported."
265 esac
268 prec=4
269 dotest="$GIT_DIR/rebase-apply"
270 sign= utf8=t keep= skip= interactive= resolved= rebasing= abort=
271 resolvemsg= resume=
272 git_apply_opt=
273 committer_date_is_author_date=
274 ignore_date=
276 while test $# != 0
278 case "$1" in
279 -i|--interactive)
280 interactive=t ;;
281 -b|--binary)
282 : ;;
283 -3|--3way)
284 threeway=t ;;
285 -s|--signoff)
286 sign=t ;;
287 -u|--utf8)
288 utf8=t ;; # this is now default
289 --no-utf8)
290 utf8= ;;
291 -k|--keep)
292 keep=t ;;
293 -r|--resolved)
294 resolved=t ;;
295 --skip)
296 skip=t ;;
297 --abort)
298 abort=t ;;
299 --rebasing)
300 rebasing=t threeway=t keep=t ;;
301 -d|--dotest)
302 die "-d option is no longer supported. Do not use."
304 --resolvemsg)
305 shift; resolvemsg=$1 ;;
306 --whitespace|--directory)
307 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
308 -C|-p)
309 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
310 --patch-format)
311 shift ; patch_format="$1" ;;
312 --reject)
313 git_apply_opt="$git_apply_opt $1" ;;
314 --committer-date-is-author-date)
315 committer_date_is_author_date=t ;;
316 --ignore-date)
317 ignore_date=t ;;
318 -q|--quiet)
319 GIT_QUIET=t ;;
321 shift; break ;;
323 usage ;;
324 esac
325 shift
326 done
328 # If the dotest directory exists, but we have finished applying all the
329 # patches in them, clear it out.
330 if test -d "$dotest" &&
331 last=$(cat "$dotest/last") &&
332 next=$(cat "$dotest/next") &&
333 test $# != 0 &&
334 test "$next" -gt "$last"
335 then
336 rm -fr "$dotest"
339 if test -d "$dotest"
340 then
341 case "$#,$skip$resolved$abort" in
342 0,*t*)
343 # Explicit resume command and we do not have file, so
344 # we are happy.
345 : ;;
347 # No file input but without resume parameters; catch
348 # user error to feed us a patch from standard input
349 # when there is already $dotest. This is somewhat
350 # unreliable -- stdin could be /dev/null for example
351 # and the caller did not intend to feed us a patch but
352 # wanted to continue unattended.
353 test -t 0
356 false
358 esac ||
359 die "previous rebase directory $dotest still exists but mbox given."
360 resume=yes
362 case "$skip,$abort" in
363 t,t)
364 die "Please make up your mind. --skip or --abort?"
367 git rerere clear
368 git read-tree --reset -u HEAD HEAD
369 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
370 git reset HEAD
371 git update-ref ORIG_HEAD $orig_head
374 if test -f "$dotest/rebasing"
375 then
376 exec git rebase --abort
378 git rerere clear
379 test -f "$dotest/dirtyindex" || {
380 git read-tree --reset -u HEAD ORIG_HEAD
381 git reset ORIG_HEAD
383 rm -fr "$dotest"
384 exit ;;
385 esac
386 rm -f "$dotest/dirtyindex"
387 else
388 # Make sure we are not given --skip, --resolved, nor --abort
389 test "$skip$resolved$abort" = "" ||
390 die "Resolve operation not in progress, we are not resuming."
392 # Start afresh.
393 mkdir -p "$dotest" || exit
395 if test -n "$prefix" && test $# != 0
396 then
397 first=t
398 for arg
400 test -n "$first" && {
401 set x
402 first=
404 case "$arg" in
406 set "$@" "$arg" ;;
408 set "$@" "$prefix$arg" ;;
409 esac
410 done
411 shift
414 check_patch_format "$@"
416 split_patches "$@"
418 # -s, -u, -k, --whitespace, -3, -C, -q and -p flags are kept
419 # for the resuming session after a patch failure.
420 # -i can and must be given when resuming.
421 echo " $git_apply_opt" >"$dotest/apply-opt"
422 echo "$threeway" >"$dotest/threeway"
423 echo "$sign" >"$dotest/sign"
424 echo "$utf8" >"$dotest/utf8"
425 echo "$keep" >"$dotest/keep"
426 echo "$GIT_QUIET" >"$dotest/quiet"
427 echo 1 >"$dotest/next"
428 if test -n "$rebasing"
429 then
430 : >"$dotest/rebasing"
431 else
432 : >"$dotest/applying"
433 if test -n "$HAS_HEAD"
434 then
435 git update-ref ORIG_HEAD HEAD
436 else
437 git update-ref -d ORIG_HEAD >/dev/null 2>&1
442 case "$resolved" in
444 case "$HAS_HEAD" in
446 files=$(git ls-files) ;;
448 files=$(git diff-index --cached --name-only HEAD --) ;;
449 esac || exit
450 if test "$files"
451 then
452 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
453 die "Dirty index: cannot apply patches (dirty: $files)"
455 esac
457 if test "$(cat "$dotest/utf8")" = t
458 then
459 utf8=-u
460 else
461 utf8=-n
463 if test "$(cat "$dotest/keep")" = t
464 then
465 keep=-k
467 if test "$(cat "$dotest/quiet")" = t
468 then
469 GIT_QUIET=t
471 if test "$(cat "$dotest/threeway")" = t
472 then
473 threeway=t
475 git_apply_opt=$(cat "$dotest/apply-opt")
476 if test "$(cat "$dotest/sign")" = t
477 then
478 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
479 s/>.*/>/
480 s/^/Signed-off-by: /'
482 else
483 SIGNOFF=
486 last=`cat "$dotest/last"`
487 this=`cat "$dotest/next"`
488 if test "$skip" = t
489 then
490 this=`expr "$this" + 1`
491 resume=
494 if test "$this" -gt "$last"
495 then
496 say Nothing to do.
497 rm -fr "$dotest"
498 exit
501 while test "$this" -le "$last"
503 msgnum=`printf "%0${prec}d" $this`
504 next=`expr "$this" + 1`
505 test -f "$dotest/$msgnum" || {
506 resume=
507 go_next
508 continue
511 # If we are not resuming, parse and extract the patch information
512 # into separate files:
513 # - info records the authorship and title
514 # - msg is the rest of commit log message
515 # - patch is the patch body.
517 # When we are resuming, these files are either already prepared
518 # by the user, or the user can tell us to do so by --resolved flag.
519 case "$resume" in
521 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
522 <"$dotest/$msgnum" >"$dotest/info" ||
523 stop_here $this
525 # skip pine's internal folder data
526 grep '^Author: Mail System Internal Data$' \
527 <"$dotest"/info >/dev/null &&
528 go_next && continue
530 test -s "$dotest/patch" || {
531 echo "Patch is empty. Was it split wrong?"
532 stop_here $this
534 if test -f "$dotest/rebasing" &&
535 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
536 -e q "$dotest/$msgnum") &&
537 test "$(git cat-file -t "$commit")" = commit
538 then
539 git cat-file commit "$commit" |
540 sed -e '1,/^$/d' >"$dotest/msg-clean"
541 else
542 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
543 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
545 (printf '%s\n\n' "$SUBJECT"; cat "$dotest/msg") |
546 git stripspace > "$dotest/msg-clean"
549 esac
551 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
552 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
553 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
555 if test -z "$GIT_AUTHOR_EMAIL"
556 then
557 echo "Patch does not have a valid e-mail address."
558 stop_here $this
561 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
563 case "$resume" in
565 if test '' != "$SIGNOFF"
566 then
567 LAST_SIGNED_OFF_BY=`
568 sed -ne '/^Signed-off-by: /p' \
569 "$dotest/msg-clean" |
570 sed -ne '$p'
572 ADD_SIGNOFF=`
573 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
574 test '' = "$LAST_SIGNED_OFF_BY" && echo
575 echo "$SIGNOFF"
577 else
578 ADD_SIGNOFF=
581 if test -s "$dotest/msg-clean"
582 then
583 cat "$dotest/msg-clean"
585 if test '' != "$ADD_SIGNOFF"
586 then
587 echo "$ADD_SIGNOFF"
589 } >"$dotest/final-commit"
592 case "$resolved$interactive" in
594 # This is used only for interactive view option.
595 git diff-index -p --cached HEAD -- >"$dotest/patch"
597 esac
598 esac
600 resume=
601 if test "$interactive" = t
602 then
603 test -t 0 ||
604 die "cannot be interactive without stdin connected to a terminal."
605 action=again
606 while test "$action" = again
608 echo "Commit Body is:"
609 echo "--------------------------"
610 cat "$dotest/final-commit"
611 echo "--------------------------"
612 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
613 read reply
614 case "$reply" in
615 [yY]*) action=yes ;;
616 [aA]*) action=yes interactive= ;;
617 [nN]*) action=skip ;;
618 [eE]*) git_editor "$dotest/final-commit"
619 action=again ;;
620 [vV]*) action=again
621 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
622 *) action=again ;;
623 esac
624 done
625 else
626 action=yes
628 FIRSTLINE=$(sed 1q "$dotest/final-commit")
630 if test $action = skip
631 then
632 go_next
633 continue
636 if test -x "$GIT_DIR"/hooks/applypatch-msg
637 then
638 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
639 stop_here $this
642 say "Applying: $FIRSTLINE"
644 case "$resolved" in
646 # When we are allowed to fall back to 3-way later, don't give
647 # false errors during the initial attempt.
648 squelch=
649 if test "$threeway" = t
650 then
651 squelch='>/dev/null 2>&1 '
653 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
654 apply_status=$?
657 # Resolved means the user did all the hard work, and
658 # we do not have to do any patch application. Just
659 # trust what the user has in the index file and the
660 # working tree.
661 resolved=
662 git diff-index --quiet --cached HEAD -- && {
663 echo "No changes - did you forget to use 'git add'?"
664 stop_here_user_resolve $this
666 unmerged=$(git ls-files -u)
667 if test -n "$unmerged"
668 then
669 echo "You still have unmerged paths in your index"
670 echo "did you forget to use 'git add'?"
671 stop_here_user_resolve $this
673 apply_status=0
674 git rerere
676 esac
678 if test $apply_status = 1 && test "$threeway" = t
679 then
680 if (fall_back_3way)
681 then
682 # Applying the patch to an earlier tree and merging the
683 # result may have produced the same tree as ours.
684 git diff-index --quiet --cached HEAD -- && {
685 say No changes -- Patch already applied.
686 go_next
687 continue
689 # clear apply_status -- we have successfully merged.
690 apply_status=0
693 if test $apply_status != 0
694 then
695 printf 'Patch failed at %s %s\n' "$msgnum" "$FIRSTLINE"
696 stop_here_user_resolve $this
699 if test -x "$GIT_DIR"/hooks/pre-applypatch
700 then
701 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
704 tree=$(git write-tree) &&
705 commit=$(
706 if test -n "$ignore_date"
707 then
708 GIT_AUTHOR_DATE=
710 parent=$(git rev-parse --verify -q HEAD) ||
711 say >&2 "applying to an empty history"
713 if test -n "$committer_date_is_author_date"
714 then
715 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
716 export GIT_COMMITTER_DATE
717 fi &&
718 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
719 ) &&
720 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
721 stop_here $this
723 if test -x "$GIT_DIR"/hooks/post-applypatch
724 then
725 "$GIT_DIR"/hooks/post-applypatch
728 go_next
729 done
731 git gc --auto
733 rm -fr "$dotest"